The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::Instrmnt Class Referenceabstract

STK instrument abstract base class. More...

`#include <Instrmnt.h>`

Inheritance diagram for stk::Instrmnt:

## Public Member Functions
| Instrmnt (void)
| Class constructor.
virtual void | clear (void)
| Reset and clear all internal state (for subclasses). More...
virtual void | noteOn (StkFloat frequency, StkFloat amplitude)=0
| Start a note with the given frequency and amplitude.
virtual void | noteOff (StkFloat amplitude)=0
| Stop a note with the given amplitude (speed of decay).
virtual void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
virtual void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
StkFloat | lastOut (unsigned int channel=0)
| Return the specified channel value of the last computed frame. More...
virtual StkFloat | tick (unsigned int channel=0)=0
| Compute one sample frame and return the specified `channel` value. More...
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Fill the StkFrames object with computed sample frames, starting at the specified channel. More...
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes. More...

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate. More...
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK instrument abstract base class.

This class provides a common interface for all STK instruments.

by Perry R. Cook and Gary P. Scavone, 1995–2019.

## Member Function Documentation

## ◆ clear()

virtual void stk::Instrmnt::clear | ( | void |  | ) |
| inlinevirtual

Reset and clear all internal state (for subclasses).

Not all subclasses implement a clear() function.

Reimplemented in stk::Saxofony, stk::BlowHole, stk::BandedWG, stk::VoicForm, stk::Flute, stk::Clarinet, stk::Bowed, stk::Mandolin, stk::Mesh2D, stk::Recorder, stk::StifKarp, stk::BlowBotl, stk::Whistle, stk::Plucked, stk::Sitar, stk::Modal, and stk::Brass.

29 {};

## ◆ lastOut()

StkFloat stk::Instrmnt::lastOut | ( | unsigned int | channel = `0` | ) |
| inline

Return the specified channel value of the last computed frame.

The `channel` argument must be less than the number of output channels, which can be determined with the channelsOut() function (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

See also
  lastFrame()

89 {
90 #if defined(_STK_DEBUG_)
91 if ( channel >= lastFrame_.channels() ) {
92 oStream_ << "Instrmnt::lastOut(): channel argument is invalid!";
93 handleError( StkError::FUNCTION_ARGUMENT );
94 }
95 #endif
96
97 return lastFrame_[channel];
98 }

## ◆ tick() [1/2]

virtual StkFloat stk::Instrmnt::tick | ( | unsigned int | channel = `0` | ) |
| pure virtual

Compute one sample frame and return the specified `channel` value.

For monophonic instruments, the `channel` argument is ignored.

Implemented in stk::FM, stk::Sampler, stk::BlowHole, stk::VoicForm, stk::Saxofony, stk::BandedWG, stk::Flute, stk::Shakers, stk::Mandolin, stk::Mesh2D, stk::StifKarp, stk::Bowed, stk::Brass, stk::Clarinet, stk::Modal, stk::Recorder, stk::BlowBotl, stk::Whistle, stk::Resonate, stk::Simple, stk::FMVoices, stk::Plucked, stk::Rhodey, stk::Wurley, stk::BeeThree, stk::Moog, stk::Sitar, stk::TubeBell, stk::Drummer, stk::PercFlut, and stk::HevyMetl.

## ◆ tick() [2/2]

virtual StkFrames& stk::Instrmnt::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| pure virtual

Fill the StkFrames object with computed sample frames, starting at the specified channel.

The `channel` argument plus the number of output channels must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implemented in stk::FM, stk::Sampler, stk::BlowHole, stk::VoicForm, stk::Saxofony, stk::BandedWG, stk::Flute, stk::Shakers, stk::Mandolin, stk::Mesh2D, stk::StifKarp, stk::Bowed, stk::Brass, stk::Clarinet, stk::Modal, stk::Recorder, stk::BlowBotl, stk::Whistle, stk::Resonate, stk::Simple, stk::FMVoices, stk::Plucked, stk::Rhodey, stk::Wurley, stk::BeeThree, stk::Moog, stk::Sitar, stk::TubeBell, stk::Drummer, stk::PercFlut, and stk::HevyMetl.

The documentation for this class was generated from the following file:

- Instrmnt.h

stk::StkFrames::channels
unsigned int channels(void) const
Return the number of channels represented by the data.
Definition: Stk.h:404
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

The Synthesis ToolKit in C++ (STK)
©1995--2019 Perry R. Cook and Gary P. Scavone. All Rights Reserved.